///home/berryj/link/bin/genMethods "-t" "SubSet<int>" "-h" "Set" "-r" "MSet<SubSet<int> >" "-I" "LINK/basic/SubSet.h" "-I" "LINK/basic/Set.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SubSet.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef SubSet<int> _SubSet_int_;
typedef Set<SubSet<int> > _Set_SubSet_int__;
static Set<SubSet<int> > s__Set_SubSet_int__;

#define _Set_SubSet_int__DATA(x) ((Set<SubSet<int> >*) (EXTDATA(x)))
#define _Set_SubSet_int__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<SubSet<int> > >::type))
#define _Set_SubSet_int__ISNT_DATA(x) (!_Set_SubSet_int__IS_DATA(x))

#define _Set_SubSet_int__CXX_DATA(x) (*(Set<SubSet<int> >*) (EXTDATA(VAL(x))))
#define _Set_SubSet_int__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<SubSet<int> > >::type))
#define _Set_SubSet_int__CXX_ISNT_DATA(x) (!_Set_SubSet_int__CXX_IS_DATA(x))


PRIMITIVE STk_init__Set_SubSet_int__()
{
	Wrapper<_Set_SubSet_int__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Set_SubSet_int__>::name, 
			Wrapper<MSet<SubSet<int> > >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_SubSet_int_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_SubSet_int_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_SubSet_int_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Set_SubSet_int__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Set_SubSet_int__Methods(void);

PRIMITIVE STk_init_methods__Set_SubSet_int__()
{
	genExtra_Set_SubSet_int__Methods();
	return UNDEFINED;
}
